import com.wb.excel.api.annotation.ColumnName;
import com.wb.excel.api.annotation.Enum;
import com.wb.excel.api.annotation.SheetName;
import com.wb.excel.api.enumeration.YesNo;

import javax.validation.constraints.NotNull;
import java.text.SimpleDateFormat;
import java.util.Date;

@SheetName("用户")
public class User {

    @NotNull
    @ColumnName("姓名")
    private String name;
    @ColumnName("出生日期时间")
    private Date date;
    @ColumnName("年纪")
    private int age;
    @Enum(target = YesNo.class)
    @ColumnName("性别")
    private YesNo sex;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    public YesNo getSex() {
        return sex;
    }

    public void setSex(YesNo sex) {
        this.sex = sex;
    }

    @Override
    public String toString() {
        return "" + name + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(date) + age + sex;
    }
}
